package com.jasamedika.medifirst2000.entities;

import java.io.Serializable;
import org.hibernate.envers.Audited;
import java.util.Date;

import javax.persistence.*;

import org.hibernate.validator.constraints.NotEmpty;

import com.jasamedika.medifirst2000.base.BaseMaster;
import javax.validation.constraints.NotNull;
import org.hibernate.validator.constraints.Length;
import org.hibernate.validator.internal.util.logging.Messages;

import com.fasterxml.jackson.annotation.JsonManagedReference;
import com.jasamedika.medifirst2000.base.BaseMaster;
import com.jasamedika.medifirst2000.helper.Caption;
import org.hibernate.envers.Audited;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;

/**
 * class ProdukTidakDiTanggung
 * 
 * @author Generator
 */
@Entity // @Audited
@Table(name = "ProdukTidakDiTanggung_M")
public class ProdukTidakDiTanggung extends BaseMaster {
	@ManyToOne
	@JoinColumn(name = "ObjectAsalProdukFk")
	@NotNull(message = "Kd Asal Produk tidak boleh kosong")

	@Caption(value = "Object Asal Produk")
	private AsalProduk asalProduk;

	public void setAsalProduk(AsalProduk asalProduk) {
		this.asalProduk = asalProduk;
	}

	public AsalProduk getAsalProduk() {
		return this.asalProduk;
	}

	@Column(name = "ObjectAsalProdukFk", insertable = false, updatable = false)
	private Integer asalProdukId;

	@ManyToOne
	@JoinColumn(name = "ObjectGolonganAsuransiFk")
	@NotNull(message = "Kd Golongan Asuransi tidak boleh kosong")

	@Caption(value = "Object Golongan Asuransi")
	private GolonganAsuransi kdGolonganAsuransi;

	public void setGolonganAsuransi(GolonganAsuransi kdGolonganAsuransi) {
		this.kdGolonganAsuransi = kdGolonganAsuransi;
	}

	public GolonganAsuransi getGolonganAsuransi() {
		return this.kdGolonganAsuransi;
	}

	@Column(name = "ObjectGolonganAsuransiFk", insertable = false, updatable = false, nullable = false)
	private Integer golonganAsuransiId;

	@ManyToOne
	@JoinColumn(name = "ObjectHubunganPesertaFk")
	@NotNull(message = "Kd Hubungan Peserta tidak boleh kosong")

	@Caption(value = "Object Hubungan Peserta")
	private HubunganPesertaAsuransi hubunganPeserta;

	public void setHubunganPeserta(HubunganPesertaAsuransi hubunganPeserta) {
		this.hubunganPeserta = hubunganPeserta;
	}

	public HubunganPesertaAsuransi getHubunganPeserta() {
		return this.hubunganPeserta;
	}

	@Column(name = "ObjectHubunganPesertaFk", insertable = false, updatable = false, nullable = false)
	private Integer hubunganPesertaId;

	@ManyToOne
	@JoinColumn(name = "ObjectKelasFk")
	@NotNull(message = "Kd Kelas tidak boleh kosong")

	@Caption(value = "Object Kelas")
	private DetailKamar kelas;

	public void setKelas(DetailKamar kelas) {
		this.kelas = kelas;
	}

	public DetailKamar getKelas() {
		return this.kelas;
	}

	@Column(name = "ObjectKelasFk", insertable = false, updatable = false, nullable = false)
	private Integer kelasId;

	@ManyToOne
	@JoinColumn(name = "ObjectKelasSelisihBerlakuFk")

	@Caption(value = "Object Kelas Selisih Berlaku")
	private DetailKamar kelasSelisihBerlaku;

	public void setKelasSelisihBerlaku(DetailKamar kelasSelisihBerlaku) {
		this.kelasSelisihBerlaku = kelasSelisihBerlaku;
	}

	public DetailKamar getKelasSelisihBerlaku() {
		return this.kelasSelisihBerlaku;
	}

	@Column(name = "ObjectKelasSelisihBerlakuFk", insertable = false, updatable = false, nullable = false)
	private Integer kelasSelisihBerlakuId;

	@ManyToOne
	@JoinColumn(name = "ObjectKelompokPasienFk")
	@NotNull(message = "Kd Kelompok Pasien tidak boleh kosong")

	@Caption(value = "Object Kelompok Pasien")
	private KelompokPasien kelompokPasien;

	public void setKelompokPasien(KelompokPasien kelompokPasien) {
		this.kelompokPasien = kelompokPasien;
	}

	public KelompokPasien getKelompokPasien() {
		return this.kelompokPasien;
	}

	@Column(name = "ObjectKelompokPasienFk", insertable = false, updatable = false)
	private Integer kelompokPasienId;

	@NotNull(message = "Kd Penjamin Pasien tidak boleh kosong")
	@Column(name = "KdPenjaminPasien", nullable = false)
	@Caption(value = "Kode Penjamin Pasien")
	private Integer kdPenjaminPasien;	

	public Integer getKdPenjaminPasien() {
		return kdPenjaminPasien;
	}

	public void setKdPenjaminPasien(Integer kdPenjaminPasien) {
		this.kdPenjaminPasien = kdPenjaminPasien;
	}

	@ManyToOne
	@JoinColumn(name = "ObjectProdukFk")
	@NotNull(message = "Kd Produk tidak boleh kosong")

	@Caption(value = "Object Produk")
	private Produk produk;

	public void setProduk(Produk produk) {
		this.produk = produk;
	}

	public Produk getProduk() {
		return this.produk;
	}

	@Column(name = "ObjectProdukFk", insertable = false, updatable = false, nullable = false)
	private Integer produkId;

	@Column(name = "NoUrutKelasSelisihBerlaku", nullable = true)
	@Caption(value = "No Urut Kelas Selisih Berlaku")
	private Byte noUrutKelasSelisihBerlaku;

	public void setNoUrutKelasSelisihBerlaku(Byte noUrutKelasSelisihBerlaku) {
		this.noUrutKelasSelisihBerlaku = noUrutKelasSelisihBerlaku;
	}

	public Byte getNoUrutKelasSelisihBerlaku() {
		return this.noUrutKelasSelisihBerlaku;
	}

	@NotNull(message = "Persen T Penjamin tidak boleh kosong")
	@Column(name = "PersenTPenjamin", nullable = false)
	@Caption(value = "Persen T Penjamin")
	private Double persenTPenjamin;

	public void setPersenTPenjamin(Double persenTPenjamin) {
		this.persenTPenjamin = persenTPenjamin;
	}

	public Double getPersenTPenjamin() {
		return this.persenTPenjamin;
	}

	@NotNull(message = "Persen T Penjamindr Selisih tidak boleh kosong")
	@Column(name = "PersenTPenjamindrSelisih", nullable = false)
	@Caption(value = "Persen T Penjamindr Selisih")
	private Double persenTPenjamindrSelisih;

	public void setPersenTPenjamindrSelisih(Double persenTPenjamindrSelisih) {
		this.persenTPenjamindrSelisih = persenTPenjamindrSelisih;
	}

	public Double getPersenTPenjamindrSelisih() {
		return this.persenTPenjamindrSelisih;
	}

	@NotNull(message = "Persen T Profile tidak boleh kosong")
	@Column(name = "PersenTProfile", nullable = false)
	@Caption(value = "Persen T Profile")
	private Double persenTProfile;

	public void setPersenTProfile(Double persenTProfile) {
		this.persenTProfile = persenTProfile;
	}

	public Double getPersenTProfile() {
		return this.persenTProfile;
	}

	@NotNull(message = "Persen T Profiledr Selisih tidak boleh kosong")
	@Column(name = "PersenTProfiledrSelisih", nullable = false)
	@Caption(value = "Persen T Profiledr Selisih")
	private Double persenTProfiledrSelisih;

	public void setPersenTProfiledrSelisih(Double persenTProfiledrSelisih) {
		this.persenTProfiledrSelisih = persenTProfiledrSelisih;
	}

	public Double getPersenTProfiledrSelisih() {
		return this.persenTProfiledrSelisih;
	}

	@Column(name = "TglBerlakuAkhir", nullable = true)
	@Caption(value = "Tanggal Berlaku Akhir")
	private Date tglBerlakuAkhir;

	public void setTglBerlakuAkhir(Date tglBerlakuAkhir) {
		this.tglBerlakuAkhir = tglBerlakuAkhir;
	}

	public Date getTglBerlakuAkhir() {
		return this.tglBerlakuAkhir;
	}

	@NotNull(message = "Tgl Berlaku Awal tidak boleh kosong")
	@Column(name = "TglBerlakuAwal", nullable = false)
	@Caption(value = "Tanggal Berlaku Awal")
	private Date tglBerlakuAwal;

	public void setTglBerlakuAwal(Date tglBerlakuAwal) {
		this.tglBerlakuAwal = tglBerlakuAwal;
	}

	public Date getTglBerlakuAwal() {
		return this.tglBerlakuAwal;
	}

	@Id
	@GeneratedValue(strategy = GenerationType.SEQUENCE, generator = "public.produktidakditanggung_m_id_seq")
	@javax.persistence.SequenceGenerator(name = "public.produktidakditanggung_m_id_seq", sequenceName = "public.produktidakditanggung_m_id_seq", allocationSize = 1)
	@Column(name = "id")
	protected Integer id;

	public Integer getId() {

		return id;
	}

	public void setId(Integer id) {
		this.id = id;
	}
}